/* 
	Applet Name	:	bump_m.class
	Version		:   1.4
	
	Author		: 	Davide Mauri
	E-Mail		: 	davide.m@askesis.it

	
	Note:
		Really thanx to Peters Walsers for sharing his own java code.
		I'm new to Java, and looking at his applets i could understand how to
		do use java to do some special FX in only one Sunday.
		
		This applet is free of charge only if you NOT use it fo commercial purposes.
 
 	Applet Parameters:
 		Texture =
            Name of the file to bumpmap

 		BumpMap =
            Name of the file that is the bump map source.
            If this param is not specified the bumpmap is the same of the Texture

 		BumpSmoothness =
             How much smooth the bump effetc will be? Good=2

 		LightColor =
            I really think that you can understand what this paramter is :-)

 		DiffuseLightColor =
            As above so below! (Malmesteen docet :-D)

 		SecondLight =
            Set to 1 to have 2 light points

        PhongLevel =
            Define the phong level. I like the 64.

 	Example:
    <applet code=bump_m.class width=150 height=150>
        <param name=Texture value=map.jpg>
        <param name=BumpSmoothness value=2>
        <param name=LightColor  value=ffffff>
        <param name=DiffuseLightColor  value=0>
        <param name=SecondLight value=0>
        <param name=PhongLevel value=64>
     </applet>
 */		
		

import java.applet.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.image.PixelGrabber;

//Import added by Josef Meile
import javax.swing.ImageIcon;

public class bump_m extends Applet implements Runnable
{
	/* Thread */
	private Thread bump_Thread 		= null;
	private boolean initialized		= false;

	/* Image Size */
	private int bump_w;
	private int bump_h;

    /* Is the bump map the same of the texture map ? */
    private boolean same;

	/* Source Images */
	private String BumpMapFile		= new String();
	private Image BumpMapImage		= null;
	private String ColorMapFile		= new String();
	private Image ColorMapImage		= null;

	/* The bumpmap buffer */
	private int BumpMap[];

	/* The 3 colormaps buffers: one for each component */
	private int ColorMap_R[];
	private int ColorMap_G[];
	private int ColorMap_B[];

	/* The same as above but for the light map */
	private int LightMap_R[];
	private int LightMap_G[];
	private int LightMap_B[];

    /* Phong level */
    private int phong=64;

	/* The double buffer */
	private Image TargetImage=null;
	private int TargetPixel[];;

	/* The Light */
	private int light[];

	/* The 2 light positions */
	private int Lx1=0;
	private int Ly1=0;
	private int Lx2=0;
	private int Ly2=0;

	/* 255 if the second light is visible, 0 else */
	private int seclig=0;

	/* Move lights */
	private float anglex=0f;
	private float angley=0f;

	/* Bump Smoothness */
	private	int bump_smoothness;

	/* Light Color */
	private	int L_Red;
	private int L_Green;
	private int L_Blue;

	/* Diffuse Light Color */
	private	int D_Red=0x00;
	private int D_Green=0x00;
	private int D_Blue=0x00;

    /* is motion blur active ? */
    //private boolean motionblur=false;

    /* Automatic or mouse drive animation */
    private boolean autoanim=true;

    /* FPS */
    private long msStart, msStart2, msNow, msDiff, msDiff2, lFrames=0;

	/* Alpha Mask */
	final static int a=0xff000000;

	/* Guess? */			
	private MemoryImageSource bump_mis;
	private ColorModel bump_cm=ColorModel.getRGBdefault();
		
	public void initialize()
	{
        /* Store the bump map size */
		setBumpSize(this.getSize().width,this.getSize().height);

		/* Get params */
		getParameters();

		/* Initialize all stuff */
		initBuffers();
		initBumpMap();
		initLight();
		
		//Set up the memory image source
		bump_mis=new MemoryImageSource(bump_w,bump_h,bump_cm,TargetPixel,0,bump_w);
		bump_mis.setFullBufferUpdates(true);
		TargetImage=createImage(bump_mis);

		//Garbage collection
		System.gc();
        showStatus("Done");
		initialized=true;
	}

	public void setBumpSize(int w, int h)
	{
		bump_w=w;
		bump_h=h;
	}

	private void getParameters()
	{
		ColorMapFile=getParameter("Texture");
        same=false;
        try
        {
		    BumpMapFile=getParameter("Bumpmap");
            if (BumpMapFile.equalsIgnoreCase(null)) same=true;
            if (BumpMapFile.equalsIgnoreCase(ColorMapFile)) same=true;
        }
        catch (RuntimeException r)
        {
            same=true;
        }

		phong=Integer.parseInt(getParameter("PhongLevel"));
		if (phong<1) phong=1;
		if (phong>254) phong=254;

		seclig=Integer.parseInt(getParameter("SecondLight"));
		seclig*=255;

		bump_smoothness=Integer.parseInt(getParameter("BumpSmoothness"));
		if (bump_smoothness<0)
			bump_smoothness=1;

		Color Temp=new Color(Integer.parseInt(getParameter("LightColor"),16));
		L_Red=Temp.getRed();
		L_Green=Temp.getGreen();
		L_Blue=Temp.getBlue();

		Color Tempd=new Color(Integer.parseInt(getParameter("DiffuseLightColor"),16));
		D_Red=Tempd.getRed();
		D_Green=Tempd.getGreen();
		D_Blue=Tempd.getBlue();
	}

	private void initBuffers()
	{
		ColorMap_R=new int[bump_w*bump_h];
		ColorMap_G=new int[bump_w*bump_h];
		ColorMap_B=new int[bump_w*bump_h];

		BumpMap=new int[bump_w*bump_h];

		LightMap_R=new int[256];
		LightMap_G=new int[256];
		LightMap_B=new int[256];

		light=new int[65536];

		TargetPixel=new int[bump_w*bump_h];

		clearDoubleBuffer();
	}

	// ----> Begin Josef Meile's patch
	// Note: the previous sintax only worked in the Applet version, but not with
	//       Java Web Start. You needed to incude a full url. Here instead, you
	//       need to pack the images on the jar file.
	Image loadImage(String name) {
		Class cls = this.getClass();
		Image iImage=new ImageIcon(cls.getResource(name)).getImage();

		if(iImage==null) {
			System.out.println("Image "+name+" not found");
			return null;
		}
		return iImage;
	}
	// <---- End patch

	private void initBumpMap()
	{
		int	pixel_val,masked_val,mid;
		int BumpMapPixel[]=new int[bump_w*bump_h];
		int ColorMapPixel[]=new int[bump_w*bump_h];
		int TempBumpMap[]=new int[bump_w*bump_h];

		// Load Image
        showStatus("bump://loading images...");

	//This was replaced by Josef Meile
        //ColorMapImage=getImage(getDocumentBase(),ColorMapFile);
	ColorMapImage=loadImage(ColorMapFile);

        ColorMapPixel=getPixels(ColorMapImage,bump_w,bump_h);
        ColorMapImage=null;

        if (!same) {
		//This was replaced by Josef Meile
    		//BumpMapImage=getImage(getDocumentBase(),BumpMapFile);
    		BumpMapImage=loadImage(BumpMapFile);

	    	BumpMapPixel=getPixels(BumpMapImage,bump_w,bump_h);
		    BumpMapImage=null;
        } else {
            BumpMapPixel = ColorMapPixel;
        }

		// Split Color map into the 3 RGB components
		for (int y=0;y<bump_h;y++)
		{
			int yoffset=y*bump_w;
			for (int x=0;x<bump_w;x++)
			{
				pixel_val=ColorMapPixel[yoffset+x];

				masked_val=pixel_val & 0x00ff0000;
				ColorMap_R[yoffset+x]=(masked_val >> 16);

				masked_val=pixel_val & 0x0000ff00;
				ColorMap_G[yoffset+x]=(masked_val >> 8);

				masked_val=pixel_val & 0x000000ff;
				ColorMap_B[yoffset+x]=(masked_val);

                if (same) {
                    BumpMapPixel[yoffset+x]=(ColorMap_R[yoffset+x]+
                                            ColorMap_G[yoffset+x]+
                                            ColorMap_B[yoffset+x])/3;
                } else {
                    BumpMapPixel[yoffset+x]&=255;
                }
        		BumpMap[yoffset+x]=BumpMapPixel[yoffset+x];
			}
		}

		// Smooth the bump map
		int temp;
		for (int a=0; a<bump_smoothness; a++)
		{
			for (int x=1;x<bump_w-1;x++)
			{
				for (int y=1;y<bump_h-1;y++)
				{
					int yoffset=y*bump_w;
					temp=(int)(BumpMap[x+yoffset]);
					temp+=(int)BumpMap[x+1+yoffset];
					temp+=(int)BumpMap[x-1+yoffset];
					temp+=(int)BumpMap[x+yoffset+bump_w];
					temp+=(int)BumpMap[x+yoffset-bump_w];
					temp+=(int)BumpMap[x+1+yoffset+bump_w];
					temp+=(int)BumpMap[x-1+yoffset+bump_w];
					temp+=(int)BumpMap[x+1+yoffset-bump_w];
					temp+=(int)BumpMap[x-1+yoffset-bump_w];
					temp/=9;
					TempBumpMap[x+yoffset]=(temp);
				}
			}
			BumpMap=TempBumpMap;
		}

		//Garbage collection
        ColorMapPixel=null;
		BumpMapPixel=null;
		TempBumpMap=null;
	}

	public void start()
	{
		if (bump_Thread == null)
		{
			bump_Thread = new Thread(this);
			bump_Thread.start();
		}
	}
	
	public void stop()
	{
		if (bump_Thread != null)
		{
			bump_Thread.stop();
			bump_Thread = null;
		}
	}

	public void run()
	{
		while(true)
		{
			repaint();
			try
			{
				bump_Thread.sleep(1);
			}
			catch (InterruptedException e)
			{
				System.out.println("bump_m://interrupted");
			}
		}
	}

	public void paint(Graphics gx)
	{
		gx.setColor(Color.black);
		gx.fillRect(0,0,this.getSize().width,this.getSize().height);
		gx.setColor(new Color(90,90,255));
		gx.drawString("bump_m",20,20);
		gx.drawLine(0,26,this.getSize().width,26);
		gx.drawLine(10,0,10,this.getSize().height);
		gx.drawString("©2000 by Davide Mauri",20,42);
        gx.drawString("v 1.4",20,62);
		gx.drawString("Please wait",20,92);
		gx.drawString("while initializing...",20,102);	
	}

	public void update(Graphics g)
	{
		if (initialized)
		{
			if (autoanim) Animate();
			//clearDoubleBuffer();
			Bump(Lx1,Ly1,Lx2,Ly2,0);
            lFrames++;
			TargetImage.flush();
			g.drawImage(TargetImage,0,0,this);
            msNow = System.currentTimeMillis();
            msDiff = msNow - msStart;
            showStatus( "FPS: " + (lFrames * 1000 / msDiff) );
		}
		else
		{
			paint(g);
			initialize();
            msStart = System.currentTimeMillis();
		}
	}			

	public boolean imageUpdate(Image image, int i1, int j1, int k, int i2, int j2)
	{
		return true;
	}

	private int[] getPixels(Image TempImage, int width, int height)
	{
		int TempPixel[]=new int [width*height];

		showStatus("bump_m://grabbing...");
		PixelGrabber pg= new PixelGrabber(TempImage,0,0,width,height,TempPixel,0,width);
		try
		{
			pg.grabPixels();
		}
		catch (InterruptedException e)
		{
		}

		return TempPixel;
	}
	
	private void clearDoubleBuffer()
	{
		for (int i=bump_w*bump_h-1;i>=0;i--)
		{
			TargetPixel[i]=a;
		}
	}

	private void Bump(int lx1, int ly1, int lx2, int ly2, int zoom )
	{
        int i, j, px, py, x, y, offs, c, r, g, b, c2;
	    int dest_red,dest_green,dest_blue;
	    int old_red,old_green,old_blue, old_pix;

	    offs = bump_w;
	    for (j=1; j<bump_h; j++)
	    {
	        TargetPixel[offs] = 0xff000000; offs++;
	        for (i=1; i<bump_w; i++)
	        {
                // Calculate the slope for each pixels
	            px = i + BumpMap[offs-1] - BumpMap[offs];
	            py = j + BumpMap[offs-bump_w] - BumpMap[offs];

                // Lookup the first light map to have to light intensisy of thi point
	            x = px + lx1;
	            y = py + ly1;
	            if ((y>=0) && (y<256) && (x>=0) && (x<256))
	                c = light[(y<<8)+x];
                else c = 0;

      			// Lookup the second light map
	            x = px + lx2;
	            y = py + ly2;
	            if ((y>=0) && (y<256) && (x>=0) && (x<256))
	                c += (light[(y<<8)+x]&seclig);

               // Do not underflow or overflow
               if (c<0) c = 0;
               if (c>255) c = 255;

  	    	    // Calculate the color of the pixel using the source image color,
	  		    //	the light intensity and the light Color

 		      	dest_red=((ColorMap_R[offs]*LightMap_R[c])>>15);
                dest_green=((ColorMap_G[offs]*LightMap_G[c])>>15);
 				dest_blue=((ColorMap_B[offs]*LightMap_B[c])>>15);

                /* Not for now
                if (motionblur) {
                    old_pix=TargetPixel[offs];
                    old_red=(old_pix & 0x00ff0000)>>16;
                    old_green=(old_pix & 0x0000ff00)>>8;
                    old_blue=(old_pix & 0x000000ff);

                    dest_red+=((13*old_red)>>4);
                    dest_green+=((13*old_green)>>4);
                    dest_blue+=((13*old_blue)>>4);
                }
                */

      			// Build the RGB color
 			    if (dest_red > 255) dest_red = 255; dest_red<<=16;
       			if (dest_green > 255) dest_green = 255; dest_green<<=8;
       			if (dest_blue > 255) dest_blue = 255;


			    // Assign the pixels
      			TargetPixel[offs]=0xff000000 |(dest_red & 0x00ff0000) | (dest_green & 0x0000ff00) | (dest_blue & 0xff);

	            offs++;
            }
        }
	}

	void initLight()
	{
		float LIGHTSIZE=2.4f;

		// Create a circular light
	    for (int j=0; j<256; j++)
	        for (int i=0; i<256; i++)
	        {
	            float dist = (128-i)*(128-i) + (128-j)*(128-j);
	            if (Math.abs(dist)>1) dist = (float)(Math.sqrt(dist));
	            int c = (int)(LIGHTSIZE*dist)+(int)((Math.random()*7)-3);
	            if (c<0) c = 0;
	            if (c>255) c = 255;
	            light[(j<<8)+i] = (255-c);
	        }


 		// Create phong intesity lookup tables
		for (int i=0;i<(255-phong);i++)
		{
			LightMap_R[i]=D_Red+(i*i/(255-phong));
			LightMap_G[i]=D_Green+(i*i/(255-phong));
			LightMap_B[i]=D_Blue+(i*i/(255-phong));
		}
		for (int i=(255-phong);i<256;i++)
		{
			LightMap_R[i]=D_Red+(i+(255-i)*(i+phong-255)/phong);
			LightMap_G[i]=D_Green+(i+(255-i)*(i+phong-255)/phong);
			LightMap_B[i]=D_Blue+(i+(255-i)*(i+phong-255)/phong);
		}

        for (int i=0; i<256; i++)
        {
            LightMap_B[i] *= L_Blue;
            LightMap_R[i] *= L_Red;
            LightMap_G[i] *= L_Green;
        }

	}

	private void Animate()
	{
		int h_bump_w = bump_w>>1;
		int h_bump_h = bump_h>>1;
		
		anglex=anglex+0.04f;
		angley=angley+0.03f;

		Lx1=((int)(h_bump_w*(Math.cos(anglex)))+h_bump_w)-(bump_w-128);
		Ly1=((int)(h_bump_h*(Math.sin(angley)))+h_bump_h)-(bump_h-128);

		Lx2=((int)(h_bump_w*(Math.cos(angley)))+h_bump_w)-(bump_w-128);
		Ly2=((int)(h_bump_h*(Math.sin(anglex)))+h_bump_h)-(bump_h-128);
	}

    public boolean mouseDown(Event evt, int x, int y)
	{
		autoanim=false;
		return true;
	}

	public boolean mouseDrag(Event evt, int x, int y)
	{
        Lx1=(bump_w>>1)-x;
        Ly1=(bump_h>>1)-y;
        showStatus("bump://x="+Lx1+" y="+Ly1);
		return true;
	}

	public boolean mouseUp(Event evt, int x, int y)
	{
		autoanim=true;
		return true;
	}
}
